#ifndef CIRCLEFORM_H
#define CIRCLEFORM_H

#include "geometricForm.hpp"

class CircleForm : public GeometricForm
{
public:
    CircleForm(p3d_point c, double r, p3d_vector3 norm);
    virtual ~CircleForm(){}

    bool isPointInForm(p3d_point p);
    double distHToPoint(p3d_point p);


    double getDistanceFromPoint(p3d_point p);
    double getPlannarDistanceFromPoint(p3d_point p);

    p3d_point getRandomPointInForm();
    std::vector<p3d_point> getFormGrid(double sampleRate);
    GeometricForm* getTransformedForm(p3d_matrix4 M);

    void draw();

private:
    p3d_point _c;
    double _r;
};
#endif // CIRCLEFORM_H
