#include "geometricForm.hpp"


using namespace std;


p3d_point GeometricForm::transformPoint(p3d_point a, p3d_matrix4 M)
{
    p3d_vector4 v,r;
    v[0] = a.x;
    v[1] = a.y;
    v[2] = a.z;
    v[3] = 1;
    p3d_matvec4Mult(M,v,r);
    p3d_point b;
    b.x = r[0];
    b.y = r[1];
    b.z = r[2];
    return b;
}

void GeometricForm::transformVector(p3d_vector3 src, p3d_matrix4 M, p3d_vector3 res)
{
//    p3d_vec3Mat4Mult(src,M,res);
    p3d_matrix3 tmpM;
    p3d_mat4ExtractRotMatrix(M,tmpM);
//    cout << "src = (" <<src[0] << " , " << src[1] << " , " << src[2] << ")"  << endl;
//    p3d_mat4Print(M,"transformation matrix");
//    p3d_mat3Print(tmpM,"rotation matrix");
    p3d_vectCopy(src,res);
    p3d_mat3_mult_vec3(tmpM,res);
//    cout << "res = (" <<res[0] << " , " << res[1] << " , " << res[2] << ")"  << endl;
}
