#include "parallelepipedForm.hpp"
#include "geometricComputations.hpp"
using namespace std;


ParallelepipedForm::ParallelepipedForm(p3d_point a, p3d_point b, p3d_point c, p3d_point d,
                                       p3d_point e, p3d_point f, p3d_point g, p3d_point h)
{
    _a = a;
    _b = b;
    _c = c;
    _d = d;
    _e = e;
    _f = f;
    _g = g;
    _h = h;
    type = "parallelepiped";
    isSupport = true;
    _norm[0] =0;
    _norm[1] =0;
    _norm[2] =0;
}

bool ParallelepipedForm::isPointInForm(p3d_point p)
{
    cout << "not implemented yet" << endl;
    return false;
}

double ParallelepipedForm::distHToPoint(p3d_point p)
{
    cout << "not implemented yet" << endl;
    return 0;
}

double ParallelepipedForm::getDistanceFromPoint(p3d_point p)
{
    cout << "not implemented yet" << endl;
    return 1000;
}

double ParallelepipedForm::getPlannarDistanceFromPoint(p3d_point p)
{
    cout << "not implemented yet" << endl;
    return 1000;
}

p3d_point ParallelepipedForm::getRandomPointInForm()
{
    cout << "not implemented yet" << endl;
    p3d_point p;
    p.x = 0;
    p.y = 0;
    p.z = 0;
    return p;
}

vector<p3d_point> ParallelepipedForm::getFormGrid(double sampleRate)
{
    vector<p3d_point> t;
    GeometricComputations GC = GeometricComputations();
    int xlenght = GC.distBetweenPoints(_a,_b)/sampleRate;
    int ylenght = GC.distBetweenPoints(_a,_c)/sampleRate;
    int zlenght = GC.distBetweenPoints(_a,_e)/sampleRate;
    double normeAB = GC.distBetweenPoints(_a,_b);
    double normeAC = GC.distBetweenPoints(_a,_c);
    double normeAE = GC.distBetweenPoints(_a,_e);

    p3d_point vectAB;
    vectAB.x = (_b.x - _a.x)/normeAB;
    vectAB.y = (_b.y - _a.y)/normeAB;
    vectAB.z = (_b.z - _a.z)/normeAB;
    p3d_point vectAC;
    vectAC.x = (_c.x - _a.x)/normeAC;
    vectAC.y = (_c.y - _a.y)/normeAC;
    vectAC.z = (_c.z - _a.z)/normeAC;
    p3d_point vectAE;
    vectAE.x = (_e.x - _a.x)/normeAE;
    vectAE.y = (_e.y - _a.y)/normeAE;
    vectAE.z = (_e.z - _a.z)/normeAE;

    for (int i = 1; i <= xlenght; i++)
    {
        for (int j = 1; j <= ylenght; j++)
        {
            for (int k = 1 ; k <= zlenght; k++)
            {
                p3d_point p;
                p.x = i*sampleRate*vectAB.x + j*sampleRate*vectAC.x + k*sampleRate*vectAE.x + _a.x;
                p.y = i*sampleRate*vectAB.y + j*sampleRate*vectAC.y + k*sampleRate*vectAE.y + _a.y;
                p.z = i*sampleRate*vectAB.z + j*sampleRate*vectAC.z + k*sampleRate*vectAE.z + _a.z;
                t.push_back(p);
            }
        }
    }





    return t;
}


GeometricForm* ParallelepipedForm::getTransformedForm(p3d_matrix4 )
{
    return new ParallelepipedForm(_a,_b,_c,_d,_e,_f,_g,_h);
}

void ParallelepipedForm::draw()
{

}
