#ifndef PLANNODE_H
#define PLANNODE_H

#include "gtpPlan.hpp"
#include "structTools.hpp"
#include "solutiondata.h"


class PlanTree;
class Task;

class PlanNode
{
public:
    PlanNode();
    ~PlanNode();

    PlanNode(PlanTree* PT, TaskSolution* TS);

    double getDuration();
    bool isInNexts(PlanNode* PN);
    bool setPrevious(PlanNode* PN);
    std::pair<int,int> getId();
    bool addToNexts(PlanNode* PN);

    TaskSolution* getTaskSolution() {return _TS;}
    PlanNode* getPrevious() {return _previous;}
    std::vector<PlanNode*> getNexts() {return _nexts;}

    double getInitTime() {return _initTime;}
    void setInitTime(double initTime) {_initTime = initTime;}

    PlanTree* getPlanTree() {return _PT;}

    bool hasSucceeded() {return _suceeded;}

    Task* getTask() {return _task;}
    void setTask(Task* t) { _task = t; }

    std::string getFormatedNumbers();
    double computePriority();

    Graph* getGraph() {return _explorationGraph;}
    void setGraph(Graph* g) { _explorationGraph = g;}

    bool operator==(PlanNode* p);


    std::map<std::string,double> backtrackingData;

    SolutionData* SD;

private:
    TaskSolution* _TS;
    PlanNode* _previous;
    std::vector<PlanNode*> _nexts;

    double _initTime;
    PlanTree* _PT;

    bool _suceeded;
    Task* _task;

    Graph* _explorationGraph;
};

#endif // PLANNODE_H
