#ifndef TASKSOLUTION_H
#define TASKSOLUTION_H

#include "taskAllSolutions.hpp"
#include "taskSubSolution.hpp"

class TaskSubSolution;

class TaskSolution
{
public:
    TaskSolution(TaskAllSolutions* taskAS, int id);
    TaskSolution();
    ~TaskSolution();


    TaskSubSolution* getFirstSubSolution();
    TaskSubSolution* getNextSubSolution(TaskSubSolution *ts);
    TaskSubSolution* getSubSolutionWithId(int subId);

    int getId() {return alternativeId;}
    void setId(int altId) {alternativeId = altId;}

    int getNbsubSolPerRobot(Robot* rob);
    std::vector<TaskSubSolution*> getTSSByRobot(Robot* rob);
    std::vector<TaskSubSolution*> getAllTSS();
    std::vector<Robot*> getInvolvedRobots();

    void setTaskAllSolutions(TaskAllSolutions *TAS){_TAS=TAS;}
    Task* getTask();

    bool isInPreviousDoneTSS(TaskSubSolution* tss);
    void addToPreviousDoneTSS(TaskSubSolution* tss);

    void setStartWS(WorldState* start_WS) { _start_WS = start_WS;}
    WorldState* getStartWS() {return _start_WS;}

    void setStopWS(WorldState* end_WS) { _end_WS = end_WS;}
    WorldState* getStopWS() {return _end_WS;}

    bool isTrajComputed() {return _trajComputed;}
    void setTrajComputed(bool val) {_trajComputed = val;}

    TaskConstraints* getTaskConstraints() {return _constraint;}
    void setTaskConstraints(TaskConstraints* TC) {_constraint = TC;}

    void addToSolutions(TaskSubSolution* tss);

    double getDuration();

    double getCost() {return _cost;}
    void setCost(double c) { _cost = c;}

    void addConf(confPtr_t q);
    confPtr_t getNextConf();

    type_data getTypeData() {return _TData;}
    void addTypeData(type_data td);
    void clearTypeData();


private:
    std::map<Robot*,std::vector<TaskSubSolution*> > solutionMap;
    int alternativeId;
    TaskAllSolutions* _TAS;

    std::vector<TaskSubSolution*> PreviousDoneTSS;

    WorldState* _start_WS;
    WorldState* _end_WS;

    bool _trajComputed;

    TaskConstraints* _constraint;

    double _cost;

    std::vector<confPtr_t> importantConfs;
    unsigned int importantConfsId;

    type_data _TData;

};
#endif // TASKSOLUTION_H
