#ifndef COOPERATIVETASK_HPP
#define COOPERATIVETASK_HPP

#include "manipulationTask.hpp"

class CooperativeTask : public ManipulationTask
{
public:
    CooperativeTask();
    virtual bool findCandidateSolutions() = 0;
    virtual bool getRandomSol() = 0;

    bool setTargetAgent(std::multimap<std::string,std::string> agents_name);

    /**
     * @brief compute the mainAgent conf based on a grasp and the object position
     * @param approachC:output
     * @param objectPosMat:input
     * @param grasp:input
     * @return return true if a conf exists
     */
    bool computeConf(confPtr_t &approachC, p3d_matrix4 objectPosMat, gpGrasp grasp);


    Robot *getTargetAgent() { return targetAgent; }

protected:
    Robot* targetAgent;
};

#endif // COOPERATIVETASK_HPP
