#ifndef DEFAULTTASK_HPP
#define DEFAULTTASK_HPP
#include "GTP/Tasks/task.hpp"

class DefaultTask : public Task
{
public:
    DefaultTask();
    virtual bool initAll();
    virtual bool initialize();
    virtual bool finalize();
    virtual bool findCandidateSolutions();
    virtual bool findConfigurations();
    virtual bool findTrajectories();
    virtual double computeCost(int altId);
    virtual bool computeSolutionTrajectories(int alternativeId);
    virtual bool setToSolution(int solutionId, bool computeMP);
    virtual bool testConstraints(int alternativeId);
    virtual bool setAgents(std::multimap<std::string,std::string> agents_name);
    virtual bool setObjects(std::multimap<std::string,std::string> objects_name);
    virtual bool setPoints(std::multimap<std::string,p3d_point> points);
    virtual bool setdata(std::multimap<std::string,std::string> additionalData);
    virtual std::string getDescr();
    virtual TaskSolution* findAlternative(bool computeMP);
    virtual std::string getTextFromValues();
    virtual void showMainObjectRandomTransform();
    virtual void smoothSolution(int alternativeId);
//    virtual vector<TaskSubSolution*> setNextTraj(TaskSubSolution* doneTSS)
//    {
//         vector<TaskSubSolution*> ts;
//         return ts;
//    }
};


#endif // DEFAULTTASK_HPP
