#include "pickQuad.hpp"
#include "API/project.hpp"
#include "GTP/GTPTools/solutionTools/taskAllSolutions.hpp"
#include "GTP/GTPTools/solutionTools/taskSolution.hpp"

#include "planner/plannerFunctions.hpp"
#include "planner/TrajectoryOptim/Classic/smoothing.hpp"

#ifdef LIGHT_PLANNER
#include "LightPlanner-pkg.h"
#endif

//####################### PickQuad ########################

PickQuad::PickQuad() : PickPlaceQuad() {

    type="pickquad";
    typeId = pickQuad;
    nbMaxLoops=20;
    result=NULL;
    _idCurrentSol=-1;


    SD->getSDMapEntry("statistics")->setMapEntry("nbMaxLoops", nbMaxLoops);
    SD->getSDMapEntry("statistics")->setMapEntry("nbParameters", 2);
    SD->getSDMapEntry("statistics")->setMapEntry("nbGikCalled", 0);
    SD->getSDMapEntry("statistics")->setMapEntry("nbMPCalled", 0);
    SD->getSDMapEntry("statistics")->setMapEntry("nbTests", 0);
    SD->getSDMapEntry("statistics")->setMapEntry("nbTotPossibleTests", nbMaxLoops);
    SD->setMapEntry("returnReport", "ERROR");

    _returnReportcount=0;
    _returnReportcountMax=0;

    _pick_goto_traj=NULL;
    _pick_arm_traj=NULL;
    _pick_approach_traj=NULL;
    _pick_traj=NULL;
    _pick_extract_traj=NULL;

    _place_goto_traj=NULL;
    _place_arm_traj=NULL;
    _place_traj=NULL;
    _place_extract_traj=NULL;

    _mainObject=NULL;
    _supportObject=NULL;
    _ghost=NULL;

    _param=NULL;

    is_pick=true;
    is_place=false;
    strcpy(_className,"PickQuad");

}

std::string PickQuad::getDescr()
{
    std::string s="Task: \nId \t\t= " + to_string(task_id) + "\nType \t\t= " + type;
    if(mainAgent)
        s+="\nMain agent \t\t= " + mainAgent->getName();
    if(_mainObject)
        s+="\nMain object \t= " + _mainObject->getName();
    return s;
}

std::string PickQuad::getTextFromValues()
{
    return "Task: " + type + ": navigate to object (mainObject) and pick it"
            + "\n    agents: "
            + "\n        mainAgent: [AGENT ID]"
            + "\n    objects: "
            + "\n        mainObect: [OBJECT ID]";
}
