#ifndef HRICS_CF_PATHLENGTHCOST_H
#define HRICS_CF_PATHLENGTHCOST_H

//#include "planners/HRI_costspace/HRICS_costspace.hpp"
#include "HRICS_CF_VirtualCostFunction.h"
#include "API/Trajectory/trajectory.hpp"

namespace HRICS {
namespace CF {

class PathLengthCost : public VirtualCostFunction
{
public:
    using VirtualCostFunction::getCost;

    PathLengthCost(CostFunctionCommon *commonCF, double min, double max, double low, double up, double maxToMeanRatio, FunctionShape shape);
    ~PathLengthCost();

    virtual double getCost(){return 0;}

    static std::string getName(){return "PathLength";}

    double getCost(std::vector<LocalPath *> &pathes);
    double getCost(API::Trajectory &path);

    ///get length run by all specified joints (sum)
    double getTotalLength(API::Trajectory &path);

    /// get length run by a joint
    double getLength(API::Trajectory &path, std::vector<int> &jointIndices);

    /// set max length from path length
    void setMaxLength(API::Trajectory &path);

private:
};

} // namespace CF
} // namespace HRICS

#endif // HRICS_CF_PATHLENGTHCOST_H
