#ifndef ENT_AGENT_H
#define ENT_AGENT_H
#include "API/Device/robot.hpp"
#include <jsoncpp/json/json.h>

#include "Logging/Logger.h"




namespace Ent {

/**
  * @brief Agent distinguish between agents and objects
  *
  * usefile: EntityTypes/Agent.json
  */
class Agent
{
    MOVE3D_STATIC_LOGGER;
public:
    Agent( std::string global_json_path);
    ~Agent();


    //json import/export
    //.global
    std::string getPath();

    //.import
    bool fetchData();
    bool importJsonFile(const std::string &path);
    bool createAgentInRob(Json::Value const & value);

    //.json conversion
    bool setToObjRob(Robot *rob, const Json::Value &value);


private:
    std::string _global_json_path;
};

} // namespace Ent

#endif // ENT_AGENT_H
