#ifndef SEM_SEMANTICSMANAGER_H
#define SEM_SEMANTICSMANAGER_H

#include "Logging/Logger.h"
#include "Sem_PlanParts.hpp"
#include "Sem_Actions.hpp"
#include "Sem_ActionsManager.hpp"

namespace Sem {


class SemanticsManager
{
    MOVE3D_STATIC_LOGGER;
public:
    SemanticsManager();
    ~SemanticsManager();

    static SemanticsManager* mainSemanticsManager();

    PlanParts *planParts() const;
    void setPlanParts(PlanParts *planParts);

    Actions *actions() const;
    void setActions(Actions *actions);

    std::string globalJsonPath() const;
    void setGlobalJsonPath(const std::string &globalJsonPath);

    bool proactive() const;
    void setProactive(bool proactive);

    ActionsManager *actionsManager() const;
    void setActionsManager(ActionsManager *actionsManager);

protected:
    void createModules();

private:
    static SemanticsManager *__mainSemanticsManager;

    std::string _globalJsonPath;
    bool _proactive;

    PlanParts *_planParts;
    Actions* _actions;
    ActionsManager *_actionsManager;
};

} // namespace Sem

#endif // SEM_SEMANTICSMANAGER_H
